using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

// http://www.codeproject.com/useritems/MSNFloatingText.asp
// http://www.dalepreston.com/Blog/2005/03/you-only-run-once.html

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        [DllImport("user32", EntryPoint = "FindWindowExA")]
        private static extern int FindWindowEx(int hWnd1, int hWnd2, string lpsz1, string lpsz2);

        [DllImport("user32", EntryPoint = "SendMessageA")]
        private static extern int ZSendMessage(int Hwnd, int wMsg, int wParam, int lParam);

        private const short WM_COPYDATA = 0x4A;

        public struct COPYDATASTRUCT
        {
            public IntPtr dwData;
            public int cbData;
            public IntPtr lpData;
        }

        public int m_commandref;
        public string m_command;
        public bool m_replyreceived;
        public string m_reply;

        public Form1()
        {
            InitializeComponent();
        }

        public int VarPtr(object e)
        {
            GCHandle GC = GCHandle.Alloc(e, GCHandleType.Pinned);
            int gc = GC.AddrOfPinnedObject().ToInt32();
            GC.Free();
            return gc;
        }

        protected override void WndProc(ref Message m)
        {
            switch (m.Msg)
            {
                case WM_COPYDATA:
                    COPYDATASTRUCT CD = (COPYDATASTRUCT)m.GetLParam(typeof(COPYDATASTRUCT));
                    byte[] B = new byte[CD.cbData];
                    IntPtr lpData = CD.lpData;
                    Marshal.Copy(lpData, B, 0, CD.cbData);
                    string strData = Encoding.Default.GetString(B);
                    if (CD.dwData == (IntPtr)m_commandref)
                    {
                        // A reply, so store it
                        m_reply = strData;
                        m_replyreceived = true;
                    }
                    else
                    {
                        // It's an event
                        AddLines("-", "-", strData);
                    }
                    break;

                default:
                    // let the base class deal with it
                    base.WndProc(ref m);
                    break;
            }
        }

        public string SendToStickies(string str)
        {
            int hWnd = 0;
            hWnd = FindWindowEx(0, hWnd, null, "ZhornSoftwareStickiesMain");

            if (hWnd == 0)
                return "";      // stickies not found
            else
            {
                // Add API code
                str = "api " + str;

                // Generate a unique number for this command
                m_commandref++;

                // Reset flag
                m_replyreceived = false;

                // Send the message to Stickies
                IntPtr ptr = (IntPtr)Marshal.StringToHGlobalAnsi(str);
                COPYDATASTRUCT cs = new COPYDATASTRUCT();
                cs.dwData = (IntPtr)m_commandref;
                cs.lpData = ptr;
                cs.cbData = str.Length + 1;
                int ret = ZSendMessage(hWnd, WM_COPYDATA, (int)Handle, VarPtr(cs));

                // Wait for a reply for a second
                int count = 0;
                while (count < 20)
                {
                    System.Threading.Thread.Sleep(50);
                    if (m_replyreceived)
                    {
                        // Free memory
                        Marshal.FreeHGlobal(ptr);

                        return m_reply;
                    }
                    count++;
                }

                // Free memory
                Marshal.FreeHGlobal(ptr);

                // We timed out so return nothing to indicate an error
                return "";
            }
        }

        // ================= My functions =================

        public void AddLines(string one, string two, string three)
        {
            listBox1.Items.Add(one);
            listBox2.Items.Add(two);
            listBox3.Items.Add(three);

            listBox1.TopIndex = listBox1.Items.Count - (listBox1.ClientSize.Height / listBox1.ItemHeight) + 1;
            listBox2.TopIndex = listBox2.Items.Count - (listBox2.ClientSize.Height / listBox2.ItemHeight) + 1;
            listBox3.TopIndex = listBox3.Items.Count - (listBox3.ClientSize.Height / listBox3.ItemHeight) + 1;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            textBox1.SelectAll();
            String str = textBox1.SelectedText;
            string reply = SendToStickies(str);
            if (reply.Length == 0)
                AddLines(str, "ERROR", "-");
            else
            {
                AddLines(str, reply, "-");
                textBox2.Text = reply;
            }
        }

        // Funky colours...
        private void button2_Click(object sender, EventArgs e)
        {
            string str = SendToStickies("get list desktop");
            if (str.Length > 0)
            {
                str = str.Substring(4);
                Random RandomClass = new Random();

                while (str.Length > 0)
                {
                    int where = str.IndexOf(",");
                    int r = RandomClass.Next(0, 255);
                    int g = RandomClass.Next(0, 255);
                    int b = RandomClass.Next(0, 255);
                    SendToStickies("set desktop " + str.Substring(0, where) + " colour " + r.ToString() + "," + g.ToString() + "," + b.ToString());
                    str = str.Substring(where + 1);
                }
            }
        }
    }
}